/**
    FREEZER - A tray icon for Deezer
    
    Serializer.java originally from Solenopsis Framework (C) 2006 Amos Brocco

    Copyright (C) 2007 Amos Brocco <amos.brocco@unifr.ch>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class Serializer {

	private PrintStream swr;

	public Serializer(OutputStream sprintr) {
		swr = new PrintStream(sprintr);
	}

	public void close() {
		swr.close();
	}

	@SuppressWarnings("unchecked")
	public void print(Object item) {
		if (item instanceof List)
			printList((List) item);
		else if (item instanceof Map)
			printDictionary((Map) item);
		else if (item instanceof String)
			printString((String) item);
	}

	@SuppressWarnings("unchecked")
	private void printList(List item) {
		swr.print('l');
		for (int i = 0; i < item.size(); i++)
			print(item.get(i));
		swr.print('e');
	}

	@SuppressWarnings("unchecked")
	private void printDictionary(Map item) {
		swr.print('d');
		Iterator keys = item.keySet().iterator();
		while (keys.hasNext()) {
			Object key = keys.next();
			Object value = item.get(key);
			print(key);
			print(value);
		}
		swr.print('e');
	}

	private void printString(String item) {
		String str = item.toString();
		swr.print(str.length());
		swr.print(':');
		swr.print(str);
	}

}
